       IDENTIFICATION DIVISION.                                                 
MACGEN PROGRAM-ID. SFFEXAMP.                                            

MACGEN AUTHOR. RDZ.
MACGEN INSTALLATION. 7.2.0.V200712022232.
MACGEN DATE-WRITTEN. 25/04/08 12:56.
MACGEN************************************************************
MACGEN* GENERATED NAVIGATOR MODULE - SFFEXAMP
MACGEN************************************************************
MACGEN* PROJECT: SFFexample
MACGEN* FLOW: SFFexample.seqflow
MACGEN* GENERATION PROPERTIES: SFFexample_generation_props.wsdl
MACGEN************************************************************                                                                
      *********************** DFHMAN20 *********************************        
      * @START_RRS_COPYRIGHT@                                                   
      * VERSION: 1                                                              
      *                                                                         
      * Licensed Materials - Property of IBM                                    
      *                                                                         
      * 5655-M15                                                                
      *                                                                         
      * (C) Copyright IBM Corp. 2000, 2005                                      
      * @END_RRS_COPYRIGHT@                                                     
      ******************************************************************        
       ENVIRONMENT DIVISION.                                                    
       CONFIGURATION SECTION.                                                   
       SOURCE-COMPUTER.  IBM-370.                                               
       OBJECT-COMPUTER.  IBM-370.                                               
       DATA DIVISION.                                                           
       WORKING-STORAGE SECTION.                                                 
       01  WS-NAVIGATOR-DEFINITION.                                             
MACGEN     05  WS-PROGRAM-ID       PIC X(08) VALUE 'SFFEXAMP'.          
MACGEN     05  WS-TRANSACTION-ID   PIC X(04) VALUE 'SFFE'.           
           05  WS-PROGRAM-TYPE     PIC S9(8) COMP VALUE ZERO.                   
           05  WS-NODE-NAME        PIC X(32) VALUE SPACES.                      
           COPY DFHMAN31.                                                       
           COPY DFHMAL2C.                       
       01  NAVIGATOR-OUTPUT-AREA.                                               

      ************************************************************
      * SFRDATARETURN copybook
      ************************************************************
         03 SFRDATARETURN.
           05 PROGLINK-RESPONSE               PIC X(8) VALUE SPACES.
           05 LINK3270-RESPONSE               PIC X(8) VALUE SPACES.
                                                             
       01  ACTIVITY-IO-AREA.                                                    

      ************************************************************
      * QUERYINPUT copybook
      ************************************************************
         03 QUERYINPUT.
           05 QUERY-INPUT-FILLER              PIC X(30) VALUE SPACES.

      ************************************************************
      * QUERYOUTPUT copybook
      ************************************************************
         03 QUERYOUTPUT.
           05 QUERY-OUTPUT-FILLER             PIC X(8) VALUE SPACES.

      ************************************************************
      * I-CMANMAIN copybook
      ************************************************************
         03 I-CMANMAIN.
           05 FILLER PIC X.

      ************************************************************
      * O-CMANMAIN copybook
      ************************************************************
         03 O-CMANMAIN.
           05 FIELD2                          PIC X(12) VALUE SPACES.
                                                             
       01  DECISION-IO-AREA.                                                    
MACGEN     02  DUMMY  PIC X(8) VALUE 'DFHDUMMY'.
                                                           
       01  ITERATION-IO-AREA.                                                   
MACGEN     02  DUMMY  PIC X(8) VALUE 'DFHDUMMY'.
                                                          
       01  LOCAL-CONTEXT-AREA.                                                  
MACGEN     02  DUMMY  PIC X(8) VALUE 'DFHDUMMY'.
                                                           
       01  SHARED-CONTEXT-AREA.                                                 
MACGEN     02  DUMMY  PIC X(8) VALUE 'DFHDUMMY'.
                                                          
       01  JOURNAL-CONTEXT-AREA.                                                
MACGEN     02  DUMMY  PIC X(8) VALUE 'DFHDUMMY'.
                                                         
       01  INPUT-DATA-CONTAINER.                                                

      ************************************************************
      * SFRDATAINPUT copybook
      ************************************************************
         03 SFRDATAINPUT.
           05 PROGLINK                        PIC X(1) VALUE 'Y'.
           05 LINK3270                        PIC X(1) VALUE 'Y'.
                                                              
       LINKAGE SECTION.                                                         
           COPY DFHMAN02.                                                       
           COPY DFHMAMOC.                                                       
       PROCEDURE DIVISION.                                                      
           COPY DFHMAN03.                                                       
       1000-MAIN-PROCESS-RTN.                                                   
           MOVE 'MAIN'    TO NSC-STEP.                                          

MACGEN     IF NSC-LAST-ACTIVITY EQUAL 'SFFEXMPL'
MACGEN       PERFORM SFFEXMPL-RETURN
MACGEN     ELSE 
MACGEN     IF NSC-LAST-ACTIVITY EQUAL 'intf-CMANMAIN'
MACGEN       PERFORM intf-CMANMAIN-RETURN
MACGEN     ELSE 
MACGEN       CONTINUE.
                                                            
           COPY DFHMAN04.                                                       
       1000-PARAGRAPH.                                                          

MACGEN* InTerminal msg_SFRDATAINPUT
MACGEN* Copybook Name: SFRDATAI.CPY
MACGEN* Message Data Structure: SFRDATAINPUT

MACGEN* Switch: Switch
MACGEN     IF  (PROGLINK OF SFRDATAINPUT = 'Y')
MACGEN       PERFORM 1010-PARAGRAPH THRU 1010-PARAGRAPH-EXIT
MACGEN      ELSE
MACGEN       PERFORM 1020-PARAGRAPH THRU 1020-PARAGRAPH-EXIT
MACGEN      END-IF.

                                                                
       1000-PARAGRAPH-EXIT.                                                     
           EXIT.                                                                
----->* END MAIN RTN / START SUB RTN *<-----

       1010-PARAGRAPH.

MACGEN* Mapping: SFFEXMPL
MACGEN     
MACGEN     MOVE 'WHAT IS THE MEANING OF LIFE?' TO
                QUERY-INPUT-FILLER OF QUERYINPUT.
      *********************** DFHMAN10 *********************************       
      * @START_RRS_COPYRIGHT@
      * VERSION: 1 
      *
      * Licensed Materials - Property of IBM
      * 
      * 5655-M15
      * 
      * (C) Copyright IBM Corp. 2007
      * @END_RRS_COPYRIGHT@
      ******************************************************************
MACGEN* CommandFC - SFFEXMPL
MACGEN     MOVE 'SFFEXMPL' TO NSC-CHILD-ACTIVITY.
           MOVE WS-DPL-PROGRAMID     TO NSC-CHILD-PROGRAM-ID.
MACGEN     MOVE 'CMAS'       TO NSC-CHILD-TRANSACTION.
MACGEN     MOVE +1       TO NSC-CHILD-TYPE.

           SET DPC-CHANNEL TO TRUE.
MACGEN     MOVE 'ADSFFEXM'      TO DPC-PROP-KEY.

MACGEN     MOVE 'DFHMA-DPL-CHNL'     TO DPC-CHANNEL-NAME.
MACGEN     MOVE 1    TO DPC-CONTAINERS-REQUEST-NO.
MACGEN     MOVE 1   TO DPC-CONTAINERS-RESPONSE-NO.

           PERFORM 2000-PROCESS-ACTIVITY-RTN.

MACGEN     
MACGEN     MOVE 'QUESTION-INPUT' TO DPC-REQUEST-CONTAINER(1).
MACGEN     MOVE LENGTH OF QUERYINPUT TO WS-DC-LENGTH.
MACGEN     EXEC CICS PUT CONTAINER(DPC-REQUEST-CONTAINER(1))
MACGEN       ACTIVITY(WS-ACTIVITY)
MACGEN       FROM(QUERYINPUT)
MACGEN       FLENGTH(WS-DC-LENGTH)
MACGEN       RESP(CICS-RESP) RESP2(CICS-RESP2)
MACGEN     END-EXEC.
MACGEN     IF CICS-RESP NOT = DFHRESP(NORMAL)
MACGEN       MOVE QUERYINPUT TO EDC-DC-DATA
MACGEN       MOVE DPC-REQUEST-CONTAINER(1) TO EDC-DC-NAME
MACGEN       PERFORM 3400-PUTCONT-ERROR-RTN
MACGEN          THRU 3400-PUTCONT-ERROR-EXIT
MACGEN     END-IF.

MACGEN     MOVE 'QUESTION-OUTPUT' TO DPC-RESPONSE-CONTAINER(1).
MACGEN     MOVE 'R' TO  DPC-RESPONSE-CONTAINER-IND(1).
MACGEN     

MACGEN          
      ************** START: SFMTRACE code ******************************
           MOVE SPACES TO WS-TRACE-ENTRY.
MACGEN     SET CHAN-LINK-TRACE-RESOURCE  TO TRUE.
           STRING "REQUEST: ", ADC-MAH-REQUESTNAME DELIMITED BY SIZE
                  " PROGRAM: ", WS-PROGRAM-ID DELIMITED BY SIZE
                  " NODE: ", WS-TRACE-RESOURCE DELIMITED BY SIZE
MACGEN            " ACTIVITY: ", 'SFFEXMPL' 
                       DELIMITED BY SIZE
                INTO WS-TRACE-ENTRY.
           EXEC CICS ENTER TRACENUM(104)
                           RESOURCE(WS-TRACE-RESOURCEID)
                           FROM(WS-TRACE-ENTRY)
                           FROMLENGTH(LENGTH OF WS-TRACE-ENTRY)
                           NOHANDLE
           END-EXEC. 
      ************** TRAILER: SFMTRACE *********************************


           PERFORM 2000-PROCESS-ACTIVITY-DC
              THRU 2000-PROCESS-ACTIVITY-EXIT.
           IF NOT NAVIGATOR-GOOD  OR  ASYNC-REQUEST
               PERFORM 9010-NAVIGATOR-RETURN.
MACGEN SFFEXMPL-RETURN.
MACGEN     
MACGEN     MOVE 'QUESTION-OUTPUT' TO DPC-RESPONSE-CONTAINER(1).
MACGEN     MOVE LENGTH OF QUERYOUTPUT TO WS-DC-LENGTH
MACGEN     EXEC CICS GET CONTAINER(DPC-RESPONSE-CONTAINER(1))
MACGEN       ACTIVITY(WS-ACTIVITY)
MACGEN       INTO(QUERYOUTPUT) FLENGTH(WS-DC-LENGTH)
MACGEN       RESP(CICS-RESP) RESP2(CICS-RESP2)
MACGEN     END-EXEC.
MACGEN     IF CICS-RESP NOT = DFHRESP(NORMAL)
MACGEN       IF NOT ((DPC-RES-OPT(1) AND
MACGEN         CICS-RESP  EQUAL DFHRESP(CONTAINERERR) AND
MACGEN         CICS-RESP2 EQUAL 10)
MACGEN       OR (CICS-RESP EQUAL DFHRESP(LENGERR) AND
MACGEN         WS-DC-LENGTH < LENGTH OF QUERYOUTPUT))
MACGEN         MOVE DPC-RESPONSE-CONTAINER(1) TO EDC-DC-NAME
MACGEN         PERFORM 3500-GETCONT-ERROR-RTN
MACGEN            THRU 3500-GETCONT-ERROR-EXIT
MACGEN       END-IF
MACGEN     END-IF.

      ************** TRAILER: DFHMAN10 *********************************

MACGEN* Mapping: SFFEXMPL
MACGEN     
MACGEN      IF QUERY-OUTPUT-FILLER OF QUERYOUTPUT
                NOT EQUAL SPACES AND LOW-VALUES  THEN 
MACGEN     MOVE QUERY-OUTPUT-FILLER OF QUERYOUTPUT
                TO PROGLINK-RESPONSE OF SFRDATARETURN
MACGEN      END-IF .

MACGEN* Switch: Switch1
MACGEN     IF  (LINK3270 OF SFRDATAINPUT = 'Y')
MACGEN       PERFORM 1020-PARAGRAPH THRU 1020-PARAGRAPH-EXIT
MACGEN      ELSE
MACGEN       PERFORM 1030-PARAGRAPH THRU 1030-PARAGRAPH-EXIT
MACGEN      END-IF.

       1010-PARAGRAPH-EXIT.
MACGEN     EXIT.

       1020-PARAGRAPH.
      *********************** DFHMAN06 *********************************
      * @START_RRS_COPYRIGHT@
      * VERSION: 0
      *
      * Licensed Materials - Property of IBM
      *
      * 5655-M15
      *                                                                         
      * (C) Copyright IBM Corp. 2000, 2005                                      
      * @END_RRS_COPYRIGHT@
      ******************************************************************
MACGEN* CommandFC - intf-CMANMAIN
MACGEN     MOVE 'intf-CMANMAIN' TO NSC-CHILD-ACTIVITY.
MACGEN     MOVE 'SFFEXAML' TO NSC-CHILD-PROGRAM-ID.
MACGEN     MOVE 'SFFC'  TO NSC-CHILD-TRANSACTION.
MACGEN     MOVE +5  TO NSC-CHILD-TYPE.
           IF CSC-STEP NOT EQUAL 'PUT1'
MACGEN        MOVE LENGTH OF I-CMANMAIN
                TO WS-CIC-LENGTH
MACGEN        MOVE I-CMANMAIN
                TO COMMAND-INPUT-CONTAINER.
MACGEN     
MACGEN          
      ************** START: SFMTRACE code ******************************
           MOVE SPACES TO WS-TRACE-ENTRY.
MACGEN     SET SUBFLOW-TRACE-RESOURCE  TO TRUE.
           STRING "REQUEST: ", ADC-MAH-REQUESTNAME DELIMITED BY SIZE
                  " PROGRAM: ", WS-PROGRAM-ID DELIMITED BY SIZE
                  " NODE: ", WS-TRACE-RESOURCE DELIMITED BY SIZE
MACGEN            " ACTIVITY: ", 'intf-CMANMAIN' 
                       DELIMITED BY SIZE
                INTO WS-TRACE-ENTRY.
           EXEC CICS ENTER TRACENUM(104)
                           RESOURCE(WS-TRACE-RESOURCEID)
                           FROM(WS-TRACE-ENTRY)
                           FROMLENGTH(LENGTH OF WS-TRACE-ENTRY)
                           NOHANDLE
           END-EXEC. 
      ************** TRAILER: SFMTRACE *********************************


           PERFORM 2000-PROCESS-ACTIVITY-RTN
              THRU 2000-PROCESS-ACTIVITY-EXIT.
           IF NOT NAVIGATOR-GOOD  OR  ASYNC-REQUEST
               PERFORM 9010-NAVIGATOR-RETURN.
MACGEN intf-CMANMAIN-RETURN.
MACGEN     
MACGEN      MOVE COMMAND-OUTPUT-CONTAINER TO 
MACGEN       O-CMANMAIN.

      ************** TRAILER: DFHMAN06 *********************************


MACGEN* Mapping: Assign
MACGEN     
MACGEN      IF FIELD2 OF O-CMANMAIN NOT EQUAL
                SPACES AND LOW-VALUES  THEN 
MACGEN     MOVE FIELD2 OF O-CMANMAIN TO
                LINK3270-RESPONSE OF SFRDATARETURN
MACGEN      END-IF .

MACGEN     PERFORM 1030-PARAGRAPH THRU 1030-PARAGRAPH-EXIT.
       1020-PARAGRAPH-EXIT.
MACGEN     EXIT.

       1030-PARAGRAPH.

MACGEN* Reply: msg_SFRDATARETURN
MACGEN* Copybook Name: SFRDATAR.CPY
MACGEN* Message Data Structure: SFRDATARETURN
      *********************** DFHMAN07 *********************************        
      * @START_RRS_COPYRIGHT@                                                   
      * VERSION: 0                                                              
      *                                                                         
      * Licensed Materials - Property of IBM                                    
      *                                                                         
      * 5655-M15                                                                
      *                                                                         
      * (C) Copyright IBM Corp. 2000, 2005                                      
      * @END_RRS_COPYRIGHT@                                                     
      ******************************************************************        
MACGEN     MOVE LENGTH OF SFRDATARETURN                                        
                                         TO WS-ODC-LENGTH                       
                                            ADC-ODC-LENGTH.                     
           SET ADDRESS OF OUTPUT-DATA-CONTAINER                                 
MACGEN      TO ADDRESS OF SFRDATARETURN.                                       
MACGEN     MOVE 'SFRDATAR'                                              
                            TO NSC-RESULT-NAME.                                 
MACGEN     MOVE '        '                                           
                            TO NSC-XML-PROGRAMID.                               
           IF WS-PROGRAM-TYPE EQUAL ZERO  AND                                   
              ASYNC-REQUEST                                                     
               PERFORM 9000-NAVIGATOR-EXIT.                                     
                                                                                
      ************** TRAILER: DFHMAN07 *********************************        
                                                                                

       1030-PARAGRAPH-EXIT.
MACGEN     EXIT.
                                                                 
           COPY DFHMAN35.                                                       
                                                                                
      ************** TRAILER: DFHMAN20 *********************************        
                                                                                
